// 100stars /	 100-line contest summer 2008
// author:	u.seiffert / gameus / mercuryus
//	date:		6.2008
// ----------------------------------------------------------------------------------------
VECTOR	temp;

#define	_zdist		skill21
#define	_player_on	skill21
#define	_pdest		skill22
#define	_turn_dist	skill23
#define	_force_x		skill30
#define	_force_y		skill31
#define	_force_z		skill32

FONT*		fnt_pan = "Times#80b";
var		gv_wait4ctrl = 0, gv_pillen, gv_time;

PANEL* pan_score 	= {digits=20,20,"stars: %03.0f", fnt_pan, 1, gv_pillen; flags=VISIBLE;}
PANEL* pan_time	= {digits=20,20,"sec.: %03.0f", fnt_pan, 1, gv_time; flags=VISIBLE;}

//------------------------------------------------------------------------------------------
function rotate_free(ENTITY* p_object, var* rcenter, var* rang){

	c_rotate(p_object,vector(rang[0],rang[1],rang[2]),USE_AXIS|IGNORE_MODELS);
	vec_set(temp.x,p_object.x);
	vec_sub(temp.x, vector(rcenter[0],rcenter[1],rcenter[2]));
	vec_rotate(temp.x,vector(rang[0],rang[1],rang[2]));
	vec_add(temp.x,vector(rcenter[0],rcenter[1],rcenter[2]));
	vec_set(p_object.x,temp.x); 
	
}
//------------------------------------------------------------------------------------------
function wait4ctrl(){
	gv_wait4ctrl=1;
	while(key_ctrl || mouse_left){wait(1);}
	gv_wait4ctrl=0;
}
//------------------------------------------------------------------------------------------
function evt_rotate(){

	proc_mode=PROC_LATE;
	my._player_on=1;	
	if(my._turn_dist!=0){rotate_free(you, my.x, vector(my._turn_dist, 0, 0));}
	
}
//------------------------------------------------------------------------------------------
action act_block_rot(){

	my.emask=(ENABLE_SHOOT);
	my.event=evt_rotate;
	my._pdest=my.pan;
	my.skin=integer(random(ent_skins(me)));
	
	while(1){
		my._player_on=0;		
		wait(1);
		
		// rotate
		if(abs(my.pan-my._pdest)>0.05){
			my._turn_dist=(my._pdest-my.pan)*time_step*.2;			
			my.pan+=my._turn_dist;
		}else{
			my._turn_dist=0;
			if(my._player_on==1){
				wait(-.3);
				my._pdest+=90;
			}
		}
	}
	
}
//-----------------------------------------------------------------------------------------
action act_block_fix(){ }
//------------------------------------------------------------------------------------------
function fall(){
	
	set(me, PASSABLE);
	while(my.z>-500){
		my.z-=time_step*10;
		wait(1);
	}
	ent_remove(me);	
}
//------------------------------------------------------------------------------------------
function evt_melt(){
	my.scale_z-=time_step*.05;
	if(random(1)>0.9){
		ent_create("schoko_tropfenS.tga", vector(my.x-20+random(40), my.y-20+random(40), my.z-10), fall);
	}
}
//------------------------------------------------------------------------------------------
action act_block_melt(){
	
	my.emask=(ENABLE_SHOOT);
	my.event=evt_melt;	
	while(my.scale_z>0.1){
		my.ambient=-100+my.scale_z*100;
		wait(1);
	}	
	ent_remove(me);	
}
//-----------------------------------------------------------------------------------------
function evt_ploing(){
	player._force_z=100;
	media_play("ploing.wav", NULL, 100);
}
//-----------------------------------------------------------------------------------------
action act_ploing(){	
	my.emask=(ENABLE_IMPACT);
	my.event=evt_ploing;	
}
//------------------------------------------------------------------------------------------
action act_pille(){
	
	set(me, PASSABLE);	
	gv_pillen+=1;
	while(!is(me, INVISIBLE)){
		my.pan=(my.pan+time_step*5+random(3))%360;
		if(vec_dist(player.x, my.x)<40){
			set(me, INVISIBLE);
		}
		wait(1);
	}	
	gv_pillen-=1;
	set(me,INVISIBLE);
	media_play("star.wav",NULL,100);
	wait(-1);
	ent_remove(me);
	
}
//------------------------------------------------------------------------------------------
action act_player(){
var 		_anm = 0, _forcepan = 0;
ENTITY* 	ent_shadow;
	
	player=me;
	c_setminmax(me);
	vec_set(my._force_x, vector(0,0,60));
	
	// the shadow
	ent_shadow=ent_create("shadow.mdl", nullvector, NULL);
	set(ent_shadow, PASSABLE);
	
	while(1){
		
		// on ground?
		my._zdist=c_trace(my.x, vector(my.x, my.y, my.z-1000), IGNORE_ME|IGNORE_PASSABLE|ACTIVATE_SHOOT);
		vec_set(ent_shadow.x, target.x);
		
		// jump & fall
		if(gv_wait4ctrl==0 && (key_ctrl || mouse_left) && my._zdist>0 && my._zdist<20){
			my._force_z=60;
			wait4ctrl();
		}else{
			accelerate(my._force_z, -15, .1);
			my._force_z=maxv(my._force_z, -25);
		}
		
		// walk
		my._force_x=20*clamp(key_w+key_cuu,0,1)-20*clamp(key_s+key_cud,0,1);
		
		// turn
		_forcepan=clamp(_forcepan-_forcepan/(2/time_step)+(((key_cul || key_a)-(key_cur || key_d))*time_step*0.001),-3, 3);
		if(abs(_forcepan)<0.05){_forcepan=0;}
		
		// move model
		vec_set(temp, my._force_x);
		vec_scale(temp, time_step);
		c_rotate(me,vector(_forcepan,0,0),IGNORE_ME|IGNORE_PASSABLE);
		c_move(me, temp, nullvector, IGNORE_ME|IGNORE_PASSABLE|GLIDE|USE_BOX);
		
		// animate
		if(abs(my._force_x)>0.5){
			_anm=(_anm+sign(my._force_x)*time_step*10);
			ent_animate(me,"walk", _anm%100, ANM_CYCLE);
		}else{
			ent_animate(me,"idle", 0, 0);
		}
		
		// camera
		vec_for_angle(temp,vector(my.pan+180,30,0));
		vec_normalize(temp,600);
  		vec_add(temp,my.x);
  		vec_set(camera.x, temp);  		
		vec_set(temp,vector(me.x, my.y, my.z+50));
		vec_sub(temp,camera.x);
		vec_to_angle(camera.pan,temp);
		
		wait(1);
	}
	
	
}
//------------------------------------------------------------------------------------------
void main(){
	
	// set video
	video_set(sys_metrics(0), sys_metrics(1), 32, 1);	
	pan_time.pos_x=screen_size.x-320;
	media_loop("100stars.mp3",NULL,40);
	
	// endless game loop
	while(1){
		// reset
		gv_pillen =0;
		gv_time = 200;
		
		// load level
		level_load("100stars.wmb");
		
		// wait for player
		while(!player){wait(1);}		
		
		// wait for game ends
		while(player.z>-400 && gv_time>0){
			gv_time-=time_step/16;
			wait(1);
		}
	}
}